"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
const require_strict_mode_1 = __importDefault(require("./require-strict-mode"));
const ts_eslint_1 = require("@typescript-eslint/experimental-utils/dist/ts-eslint");
const experimental_utils_1 = require("@typescript-eslint/experimental-utils");
const strictRuleTester = new ts_eslint_1.RuleTester({
    parserOptions: {
        sourceType: "module",
        project: "./tsconfig.tests.json",
    },
    parser: require.resolve("@typescript-eslint/parser"),
});
// eslint-disable-next-line functional/no-expression-statement
strictRuleTester.run("require-strict-mode", require_strict_mode_1.default, {
    valid: [
        {
            filename: "file.ts",
            code: "const foo = 'foo';",
        },
    ],
    invalid: [],
});
const nonStrictRuleTester = new ts_eslint_1.RuleTester({
    parserOptions: {
        sourceType: "module",
        project: "./tsconfig.tests.non-strict.json",
    },
    parser: require.resolve("@typescript-eslint/parser"),
});
// eslint-disable-next-line functional/no-expression-statement
nonStrictRuleTester.run("require-strict-mode", require_strict_mode_1.default, {
    valid: [],
    invalid: [
        {
            filename: "file.ts",
            code: "const foo = 'foo';",
            errors: [
                {
                    messageId: "errorStringGeneric",
                    type: experimental_utils_1.AST_NODE_TYPES.Program,
                },
            ],
        },
    ],
});
